var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { Component } from "react";
// Import GRUI
// @ts-ignore
import { GRUI } from "./js/index";
import { GroupHeader } from "./components/GroupHeader";
import EventListeners from "./events/EventListeners";
import { DateFilter } from "./filterFields/DateFilter";
import { SelectFilter } from "./filterFields/SelectFilter";
import { TextFilter } from "./filterFields/TextFilter";
/**
 * Event name mapping from React to Extjs
 */
var filterTypes = {
    string: React.createElement(TextFilter, null),
    list: React.createElement(SelectFilter, null),
    date: React.createElement(DateFilter, null),
    number: React.createElement(TextFilter, null),
};
var reactToExtListenersMap = {
    onRowClick: "childsingletap",
    onSelect: "selectionChange",
    onColumnHide: "columnhide",
    onBeforeComplete: "beforecomplete",
    onBeforeGroupCollapse: "beforegroupcollapse",
    onBeforeGroupExpand: "beforegroupexpand",
    onBeforeEdit: "beforeEdit",
    onColumnMove: "columnmove",
    onDeSelect: "deselect",
    onColumnAdd: "columnadd",
    onColumnResize: "columnresize",
    onCellSelection: "cellselection",
    onBeforeStartEdit: "beforestartedit",
    onColumnSort: "columnsort",
    onStartEdit: "startedit",
    onUpdateData: "updatedata",
    onComplete: "complete",
    onColumnSelection: "columnselection",
    onGridFocus: "focus",
    onGridBlur: "blur",
    onColumnMenuCreated: "columnmenucreated",
    onEdit: "edit",
    onCancelEdit: "canceledit",
    onValidateEdit: "validateedit",
    onPainted: "painted",
    onInitialize: "initialize",
    onChildDoubleTap: "childdoubletap",
    onColumnShow: "columnshow",
};
var SenchaGrid = /** @class */ (function (_super) {
    __extends(SenchaGrid, _super);
    function SenchaGrid(props) {
        var _this = _super.call(this, props) || this;
        _this.columns = [];
        _this.childrenRefs = [];
        //Mapper for React to Extjs events
        _this.reactToExtListnersMap = reactToExtListenersMap;
        _this.licenseKey = "";
        _this.gridRef = React.createRef();
        _this.listenerFnMap = new EventListeners(props);
        _this.state = {
            renderColumns: false,
            renderedGrid: false,
        };
        _this.gotoFirstPage = _this.gotoFirstPage.bind(_this);
        _this.gotoLastPage = _this.gotoLastPage.bind(_this);
        _this.gotoPage = _this.gotoPage.bind(_this);
        _this.gotoNextPage = _this.gotoNextPage.bind(_this);
        _this.gotoPrevPage = _this.gotoPrevPage.bind(_this);
        _this.setPageSize = _this.setPageSize.bind(_this);
        _this.getPageSize = _this.getPageSize.bind(_this);
        if (SenchaGrid.getLicense()) {
            _this.licenseKey = SenchaGrid.getLicense();
        }
        return _this;
    }
    SenchaGrid.setLicense = function (license) {
        var grid = SenchaGrid;
        grid["license"] = license;
    };
    SenchaGrid.getLicense = function () {
        var grid = SenchaGrid;
        return grid.license;
    };
    SenchaGrid.prototype.componentDidMount = function () {
        var children = React.Children.toArray(this.props.children);
        this.childrenRefs = this.getColumnReference(children);
        // First render the columns so the props can be fetched
        this.setState(__assign(__assign({}, this.state), { renderColumns: true }), 
        // After the render columns, render the grid
        this.renderGrid);
    };
    /**
     * Create the references for columns and subcolumns
     */
    SenchaGrid.prototype.getColumnReference = function (children) {
        var columnRefs = [];
        for (var i = 0; i < children.length; i++) {
            var childColumns = children[i].props.children;
            if (childColumns && childColumns.length > 0) {
                var childColumnRef = this.getColumnReference(childColumns);
                columnRefs.push({ ref: React.createRef(), children: childColumnRef });
            }
            else {
                columnRefs.push({ ref: React.createRef() });
            }
        }
        return columnRefs;
    };
    /**
     * Render the Grid with properties used.
     */
    SenchaGrid.prototype.renderGrid = function () {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
        // Only instantiate and initialize the grid once per React component
        if (this.gridRef != null &&
            this.gridRef.current != null &&
            this.gridRef.current.children != null &&
            this.gridRef.current.children.length === 0) {
            var gridLiteralObjectConfig = __assign({ renderTo: this.gridRef.current }, this.props);
            //Add events to the extjs grid Dynamically
            this.addEventlistners(gridLiteralObjectConfig);
            // Set width and height to 100%
            if ((_b = (_a = this.props) === null || _a === void 0 ? void 0 : _a.style) === null || _b === void 0 ? void 0 : _b.width) {
                gridLiteralObjectConfig.width = (_d = (_c = this.props) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.width;
            }
            else {
                gridLiteralObjectConfig.width = "100%";
            }
            if ((_f = (_e = this.props) === null || _e === void 0 ? void 0 : _e.style) === null || _f === void 0 ? void 0 : _f.height) {
                gridLiteralObjectConfig.height = (_h = (_g = this.props) === null || _g === void 0 ? void 0 : _g.style) === null || _h === void 0 ? void 0 : _h.height;
            }
            else {
                gridLiteralObjectConfig.height = "100%";
            }
            // Get the columns from jsx or props.columns
            gridLiteralObjectConfig.columns = this.getColumnsFromConfig(this.props);
            if (gridLiteralObjectConfig.children) {
                delete gridLiteralObjectConfig.children;
            }
            // Can't send loadData as it will override the existing store's load data method
            if (gridLiteralObjectConfig.store &&
                gridLiteralObjectConfig.store.loadData) {
                gridLiteralObjectConfig.store.getRowData =
                    gridLiteralObjectConfig.store.loadData;
                delete gridLiteralObjectConfig.store.loadData;
            }
            // Cache the columns for easy reference
            this.columns = gridLiteralObjectConfig.columns;
            // Group Footer
            if (gridLiteralObjectConfig.groupFooter) {
                if (typeof gridLiteralObjectConfig.groupFooter === "object") {
                    gridLiteralObjectConfig.groupFooter = __assign({ xtype: "gridsummaryrow" }, gridLiteralObjectConfig.groupFooter);
                }
                else {
                    gridLiteralObjectConfig.groupFooter = {
                        xtype: "gridsummaryrow",
                    };
                }
            }
            // Default Group header component
            if (!gridLiteralObjectConfig.groupHeader) {
                gridLiteralObjectConfig.groupHeader = React.createElement(GroupHeader, null);
            }
            // For adding plugin store object
            if (!gridLiteralObjectConfig.store) {
                gridLiteralObjectConfig.store = {};
            }
            gridLiteralObjectConfig.configurator = this.licenseKey;
            gridLiteralObjectConfig.filterComponents = filterTypes;
            if (((_j = this.props) === null || _j === void 0 ? void 0 : _j.display) === "tree") {
                gridLiteralObjectConfig.store = GRUI.create("GRUI.data.TreeStore", gridLiteralObjectConfig.treeData);
                this.grid = GRUI.create("GRUI.grid.Tree", gridLiteralObjectConfig);
            }
            else if (((_k = this.props) === null || _k === void 0 ? void 0 : _k.display) === "locked") {
                this.grid = GRUI.create("GRUI.grid.locked.Grid", gridLiteralObjectConfig);
            }
            else if (((_l = this.props) === null || _l === void 0 ? void 0 : _l.display) === "treeGroupedGrid") {
                this.grid = GRUI.create("GRUI.grid.TreeGrouped", gridLiteralObjectConfig);
            }
            else {
                this.grid = GRUI.create("GRUI.grid.Grid", gridLiteralObjectConfig);
            }
            this.setDefaultFilter();
            this.setState(__assign(__assign({}, this.state), { renderedGrid: true }));
        }
    };
    //Make the filtering by default
    SenchaGrid.prototype.setDefaultFilter = function () {
        if (!this.grid.getStore().getFilters()) {
            this.setFilters([{ property: "", value: "" }]);
        }
    };
    SenchaGrid.prototype.componentDidUpdate = function (prevProps) {
        var _this = this;
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1;
        var _2 = this.state, renderColumns = _2.renderColumns, renderedGrid = _2.renderedGrid;
        if (!renderColumns || !renderedGrid) {
            // Not ready to update values
            return;
        }
        //Used to update the store by using filter via state in use-case/searching.stories.tsx
        if ((prevProps === null || prevProps === void 0 ? void 0 : prevProps.filters) !== this.props.filters) {
            this.setFilters(this.props.filters);
        }
        // JSX children are columns
        if (
        // @ts-ignore
        prevProps.children !== undefined &&
            this.props.children !== undefined &&
            // @ts-ignore
            prevProps.children !== this.props.children &&
            // @ts-ignore
            ((_a = prevProps.children) === null || _a === void 0 ? void 0 : _a.length) !== ((_b = this.props.children) === null || _b === void 0 ? void 0 : _b.length)) {
            //Call setstate to create the new column instances
            // After the new Columns instances are created then we will update the Extjs Grid with new columns configs
            this.setState(__assign(__assign({}, this.state), { renderColumns: true }), function () {
                var columns = _this.getColumnsFromConfig(_this.props);
                _this.setColumns(columns);
            });
        }
        // TODO determine if the data value has changed
        if (prevProps.data !== undefined &&
            this.props.data !== undefined &&
            prevProps.data !== this.props.data) {
            var data = this.props.data;
            this.setData(data);
        }
        var store = this.props.store;
        if (store !== undefined &&
            JSON.stringify(prevProps.store) !== JSON.stringify(this.props.store)) {
            this.setStore(store);
        }
        var itemRipple = this.props.itemRipple;
        if (itemRipple !== undefined &&
            prevProps.itemRipple !== this.props.itemRipple) {
            this.setItemRipple(itemRipple);
        }
        var style = this.props.style;
        if (style !== undefined && prevProps.style !== this.props.style) {
            this.setStyle(style);
        }
        var shadow = this.props.shadow;
        if (shadow !== undefined && prevProps.shadow !== this.props.shadow) {
            this.setShadow(shadow);
        }
        var columnLines = this.props.columnLines;
        if (columnLines !== undefined &&
            prevProps.columnLines !== this.props.columnLines) {
            this.setColumnLines(columnLines);
        }
        var grouped = this.props.grouped;
        if (grouped !== undefined && prevProps.grouped !== this.props.grouped) {
            this.setGrouped(grouped);
        }
        var variableHeights = this.props.grouped;
        if (variableHeights !== undefined &&
            prevProps.variableHeights !== this.props.variableHeights) {
            this.setVariableHeights(variableHeights);
        }
        var sortable = this.props.sortable;
        if (sortable !== undefined && prevProps.sortable !== this.props.sortable) {
            this.setSortable(sortable);
        }
        var sorter = this.props.sorter;
        if (sorter !== undefined && prevProps.sorter !== this.props.sorter) {
            this.setSorter(sorter);
        }
        var rowNumbers = this.props.rowNumbers;
        if (rowNumbers !== undefined &&
            prevProps.rowNumbers !== this.props.rowNumbers) {
            this.setRowNumbers(rowNumbers);
        }
        var hideHeaders = this.props.hideHeaders;
        if (hideHeaders !== undefined &&
            prevProps.hideHeaders !== this.props.hideHeaders) {
            this.setHideHeaders(hideHeaders);
        }
        var selectable = this.props.selectable;
        if (selectable !== undefined &&
            ((_c = prevProps.selectable) === null || _c === void 0 ? void 0 : _c.cells) !== ((_d = this.props.selectable) === null || _d === void 0 ? void 0 : _d.cells)) {
            this.setSelectable(selectable);
        }
        if (selectable !== undefined &&
            ((_e = prevProps.selectable) === null || _e === void 0 ? void 0 : _e.checkbox) !== ((_f = this.props.selectable) === null || _f === void 0 ? void 0 : _f.checkbox)) {
            this.setSelectable(selectable);
        }
        if (selectable !== undefined &&
            ((_g = prevProps.selectable) === null || _g === void 0 ? void 0 : _g.checkboxSelect) !==
                ((_h = this.props.selectable) === null || _h === void 0 ? void 0 : _h.checkboxSelect)) {
            this.setSelectable(selectable);
        }
        if (selectable !== undefined &&
            ((_j = prevProps.selectable) === null || _j === void 0 ? void 0 : _j.columns) !== ((_k = this.props.selectable) === null || _k === void 0 ? void 0 : _k.columns)) {
            this.setSelectable(selectable);
        }
        if (selectable !== undefined &&
            ((_l = prevProps.selectable) === null || _l === void 0 ? void 0 : _l.deselectable) !== ((_m = this.props.selectable) === null || _m === void 0 ? void 0 : _m.deselectable)) {
            this.setSelectable(selectable);
        }
        if (selectable !== undefined &&
            ((_o = prevProps.selectable) === null || _o === void 0 ? void 0 : _o.disabled) !== ((_p = this.props.selectable) === null || _p === void 0 ? void 0 : _p.disabled)) {
            this.setSelectable(selectable);
        }
        if (selectable !== undefined &&
            ((_q = prevProps.selectable) === null || _q === void 0 ? void 0 : _q.drag) !== ((_r = this.props.selectable) === null || _r === void 0 ? void 0 : _r.drag)) {
            this.setSelectable(selectable);
        }
        if (selectable !== undefined &&
            ((_s = prevProps.selectable) === null || _s === void 0 ? void 0 : _s.extensible) !== ((_t = this.props.selectable) === null || _t === void 0 ? void 0 : _t.extensible)) {
            this.setSelectable(selectable);
        }
        if (selectable !== undefined &&
            ((_u = prevProps.selectable) === null || _u === void 0 ? void 0 : _u.headerCheckbox) !==
                ((_v = this.props.selectable) === null || _v === void 0 ? void 0 : _v.headerCheckbox)) {
            this.setSelectable(selectable);
        }
        if (selectable !== undefined &&
            ((_w = prevProps.selectable) === null || _w === void 0 ? void 0 : _w.reducible) !== ((_x = this.props.selectable) === null || _x === void 0 ? void 0 : _x.reducible)) {
            this.setSelectable(selectable);
        }
        if (selectable !== undefined &&
            ((_y = prevProps.selectable) === null || _y === void 0 ? void 0 : _y.rows) !== ((_z = this.props.selectable) === null || _z === void 0 ? void 0 : _z.rows)) {
            this.setSelectable(selectable);
        }
        // if (
        //   selectable !== undefined &&
        //   prevProps.selectable?.toggleOnClick !==
        //     this.props.selectable?.toggleOnClick
        // ) {
        //   this.setSelectable(selectable);
        // }
        if (selectable !== undefined &&
            ((_0 = prevProps.selectable) === null || _0 === void 0 ? void 0 : _0.mode) !== ((_1 = this.props.selectable) === null || _1 === void 0 ? void 0 : _1.mode)) {
            this.setSelectable(selectable);
        }
        var theme = this.props.enableDarkTheme;
        if (theme !== undefined &&
            prevProps.enableDarkTheme !== this.props.enableDarkTheme) {
            this.setEnableDarkTheme(theme);
        }
        var enableColumnMove = this.props.enableColumnMove;
        if (enableColumnMove !== undefined &&
            prevProps.enableColumnMove !== this.props.enableColumnMove) {
            this.setEnableColumnMove(enableColumnMove);
        }
    };
    /**
     * Add the  events dynamically to the grid depends on the React Events.
     */
    SenchaGrid.prototype.addEventlistners = function (gridLiteralObjectConfig) {
        for (var key in this.reactToExtListnersMap) {
            var newKey = key;
            var property = this.getProperty(this.props, newKey);
            if (property) {
                delete gridLiteralObjectConfig[key];
                if (!gridLiteralObjectConfig.listeners) {
                    gridLiteralObjectConfig.listeners = {};
                }
                gridLiteralObjectConfig.listeners[this.reactToExtListnersMap[key]] = this.listenerFnMap[this.reactToExtListnersMap[key]].bind(this.listenerFnMap);
            }
        }
    };
    SenchaGrid.prototype.getProperty = function (props, propertyName) {
        return props[propertyName]; // props[propertyName] is of type T[K]
    };
    SenchaGrid.prototype.componentWillUnmount = function () {
        if (this.grid != null &&
            this.gridRef != null &&
            this.gridRef.current != null &&
            this.gridRef.current.children != null &&
            this.gridRef.current.children.length !== 0) {
            this.grid.destroy();
            this.grid = null;
        }
    };
    /**
     * Add the  reference to the columns.
     */
    SenchaGrid.prototype.getColumnsWithRef = function (children, childref) {
        if (childref === void 0) { childref = this.childrenRefs; }
        var childrenWithRefs = [];
        var _loop_1 = function (i) {
            var child = children[i];
            if (child.props.children) {
                if (!childref[i] || !childref[i].children) {
                    childref[i] = { ref: React.createRef(), children: [] };
                }
                var childrenRef = childref[i].children;
                var children_1 = this_1.getColumnsWithRef(child.props.children, childrenRef);
                var ChildWithRef = React.forwardRef(function (props, ref) {
                    return React.cloneElement(child, __assign(__assign({}, props), { ref: ref }), children_1);
                });
                childrenWithRefs.push(React.createElement(ChildWithRef, __assign({ key: i }, child.props, { ref: childref[i].ref })));
                childrenRef.length = child.props.children.length;
            }
            else {
                if (!childref[i]) {
                    childref[i] = { ref: React.createRef() };
                }
                var ChildWithRef = React.forwardRef(function (props, ref) {
                    return React.cloneElement(child, __assign(__assign({}, props), { ref: ref }));
                });
                childrenWithRefs.push(React.createElement(ChildWithRef, __assign({ key: i }, child.props, { ref: childref[i].ref })));
            }
        };
        var this_1 = this;
        for (var i = 0; i < children.length; i++) {
            _loop_1(i);
        }
        return childrenWithRefs;
    };
    SenchaGrid.prototype.render = function () {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        var pagingToolbar = this.props.pagingToolbar;
        var renderColumns = this.state.renderColumns;
        var style = {
            width: "100%",
            height: "100%",
        };
        if ((_b = (_a = this.props) === null || _a === void 0 ? void 0 : _a.style) === null || _b === void 0 ? void 0 : _b.width) {
            style.width = (_d = (_c = this.props) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.width;
        }
        if ((_f = (_e = this.props) === null || _e === void 0 ? void 0 : _e.style) === null || _f === void 0 ? void 0 : _f.height) {
            style.height = (_h = (_g = this.props) === null || _g === void 0 ? void 0 : _g.style) === null || _h === void 0 ? void 0 : _h.height;
        }
        var childrenWithRefs = [];
        if (renderColumns) {
            var children = React.Children.toArray(this.props.children);
            childrenWithRefs = this.getColumnsWithRef(children);
            this.childrenRefs.length = children.length;
        }
        var pagingToolbarWithCallbacks;
        if (pagingToolbar) {
            pagingToolbarWithCallbacks = React.cloneElement(pagingToolbar, {
                gotoFirst: this.gotoFirstPage,
                gotoLast: this.gotoLastPage,
                gotoPage: this.gotoPage,
                gotoNext: this.gotoNextPage,
                gotoPrev: this.gotoPrevPage,
                getPageSize: this.getPageSize,
                setPageSize: this.setPageSize,
            });
        }
        return (React.createElement(React.Fragment, null,
            childrenWithRefs,
            React.createElement("div", { ref: this.gridRef, style: style, className: this.props.class }),
            pagingToolbarWithCallbacks));
    };
    /**
     * Get the columnsn from jsx children or config.columns.
     * @param props ColumnProps[]
     */
    SenchaGrid.prototype.getColumnsFromConfig = function (props) {
        // Note: the children jsx property is not in the props interface
        // @ts-ignore
        var jsxChildren = React.Children.toArray(props.children);
        return this.getNestedColumnConfig(jsxChildren);
    };
    /**
     * Get the column and its children config from jsx children or config.columns.
     */
    SenchaGrid.prototype.getNestedColumnConfig = function (jsxChildren, childrenRefs) {
        var _a;
        if (childrenRefs === void 0) { childrenRefs = this.childrenRefs; }
        var columnsConfigs = [];
        for (var i = 0; i < jsxChildren.length; i++) {
            var children = jsxChildren[i].props.children;
            var columnRef = (_a = childrenRefs[i].ref) === null || _a === void 0 ? void 0 : _a.current;
            if (children && children.length > 0) {
                var childRef = childrenRefs[i].children;
                var config = this.getNestedColumnConfig(children, childRef);
                var columnConfig = __assign(__assign({}, columnRef.getColumnConfig()), { columns: config });
                columnsConfigs.push(columnConfig);
            }
            else {
                columnsConfigs.push(columnRef.getColumnConfig());
            }
        }
        return columnsConfigs;
    };
    /**
     * Clear all the selected rows
     */
    SenchaGrid.prototype.clearSelection = function () {
        this.grid.getSelectable().getSelection().clear();
    };
    /**
     * Set the columns configurations.
     * @param columns set using ColumnProps[] array
     */
    SenchaGrid.prototype.setColumns = function (columns) {
        this.columns = columns;
        // TODO figure out why a copy of the object has to be used
        this.grid.setColumns(__spreadArray([], columns, true));
    };
    /**
     * Returns columns configurations.
     * @returns ColumnProps[]
     */
    SenchaGrid.prototype.getColumns = function () {
        return this.columns;
    };
    /**
     * Set the data array of models which the grid will use to render the data.
     */
    SenchaGrid.prototype.setData = function (data) {
        // TODO figure out why a copy of the object has to be used
        this.grid.setData(__spreadArray([], data, true));
    };
    /**
     * Set the filters configuration.
     */
    SenchaGrid.prototype.setFilters = function (filters) {
        if (filters) {
            // TODO figure out why a copy of the object has to be used
            this.grid.getStore().setFilters(__spreadArray([], filters, true));
        }
        else {
            this.grid.getStore().setFilters(null);
        }
    };
    /**
     * Get the data store.
     */
    SenchaGrid.prototype.getStore = function () {
        // TODO define return datatype
        // TODO provide an interface to the store.
        return this.grid.getStore();
    };
    /**
     * Set the Grid data store.
     */
    SenchaGrid.prototype.setStore = function (store) {
        this.grid.setStore(store);
    };
    /**
     * Get the filters configuration.
     */
    SenchaGrid.prototype.getFilters = function () {
        // TODO refactor return into simple json
        return this.grid.getStore().getFilters();
    };
    /**
     * Display a shadow.
     */
    SenchaGrid.prototype.setShadow = function (shadow) {
        this.grid.setShadow(shadow);
    };
    /**
     * Display column lines.
     */
    SenchaGrid.prototype.setColumnLines = function (columnLines) {
        this.grid.setColumnLines(columnLines);
    };
    /**
     * Turning on the grouping features.
     */
    SenchaGrid.prototype.setGrouped = function (grouped) {
        this.grid.setGrouped(grouped);
    };
    /**
     * Allow the grid to display variable heights in rows.
     */
    SenchaGrid.prototype.setVariableHeights = function (variableHeights) {
        this.grid.setVariableHeights(variableHeights);
    };
    /**
     * Allow the grid to be sorted.
     */
    SenchaGrid.prototype.setSortable = function (sortable) {
        this.grid.setSortable(sortable);
    };
    /**
     * Set the grid sort configuration.
     * TODO define sorter data type
     */
    SenchaGrid.prototype.setSorter = function (sorter) {
        this.grid.setSorter(sorter);
    };
    /**
     * Display row numbers on the left.
     */
    SenchaGrid.prototype.setRowNumbers = function (rowNumbers) {
        this.grid.setRowNumbers(rowNumbers);
    };
    /**
     * Display the grid header.
     */
    SenchaGrid.prototype.setHideHeaders = function (hideHeaders) {
        this.grid.setHideHeaders(hideHeaders);
    };
    /**
     * Display or customize the item ripple or material inkwell animation when clicking on the grid.
     */
    SenchaGrid.prototype.setItemRipple = function (itemRipple) {
        this.grid.setItemRipple(itemRipple);
    };
    /**
     * Set the CSS.properties of the outer grid div.
     */
    SenchaGrid.prototype.setStyle = function (style) {
        this.grid.setStyle(style);
    };
    /**
     * Allow the grid to be selectable and how it will be selectable.
     */
    SenchaGrid.prototype.setSelectable = function (selectable) {
        this.grid.setSelectable(selectable);
    };
    SenchaGrid.prototype.setEnableDarkTheme = function (themeFlg) {
        this.grid.setEnableDarkTheme(themeFlg);
    };
    SenchaGrid.prototype.setEnableColumnMove = function (columnMove) {
        this.grid.setEnableColumnMove(columnMove);
    };
    /**
     * Ask the grid to go to the next page.
     */
    SenchaGrid.prototype.gotoNextPage = function () {
        this.getStore().nextPage();
    };
    /**
     * Ask the grid to go to the previous page.
     */
    SenchaGrid.prototype.gotoPrevPage = function () {
        this.getStore().previousPage();
    };
    /**
     * Ask the grid to go to a specific page.
     */
    SenchaGrid.prototype.gotoPage = function (page) {
        var totalCount = Math.ceil(this.getStore().getTotalCount() / this.getPageSize());
        if (page < 1 || page > totalCount) {
            // Reset the field value
        }
        else {
            this.getStore().loadPage(page);
        }
    };
    /**
     * Ask the grid to go to the last page.
     */
    SenchaGrid.prototype.gotoLastPage = function () {
        var totalCount = Math.ceil(this.getStore().getTotalCount() / this.getPageSize());
        this.getStore().loadPage(totalCount);
    };
    /**
     * Ask the grid to go to the first page.
     */
    SenchaGrid.prototype.gotoFirstPage = function () {
        this.getStore().loadPage(1);
    };
    SenchaGrid.prototype.setPageSize = function (size) {
        this.getStore().setPageSize(size);
    };
    SenchaGrid.prototype.getPageSize = function () {
        return this.getStore().getPageSize();
    };
    SenchaGrid.prototype.clearFilter = function () {
        return this.getStore().clearFilter();
    };
    return SenchaGrid;
}(Component));
export { SenchaGrid };
export default SenchaGrid;
