var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { Component } from "react";
import BooleanEditor from "../editors/BooleanEditor";
import { defaultColumnRendererStyle, } from "./Column";
/**
 *
 */
var BooleanColumn = /** @class */ (function (_super) {
    __extends(BooleanColumn, _super);
    function BooleanColumn(props) {
        var _this = _super.call(this, props) || this;
        _this.state = __assign(__assign({}, _this.props), { sorter: { sorterFn: _this.sorterFn.bind(_this) }, renderer: React.createElement(BooleanRenderer, { style: props.style }), editor: React.createElement(BooleanEditor, null), validator: _this.validateBoolean });
        return _this;
    }
    BooleanColumn.prototype.sorterFn = function (a, b) {
        var str_a = a[this.state.field].toString();
        var str_b = b[this.state.field].toString();
        return str_a.localeCompare(str_b, undefined, {
            numeric: true,
            sensitivity: "base",
        });
    };
    BooleanColumn.prototype.validateBoolean = function (value) {
        value = String(value);
        if (value !== "true" && value !== "false") {
            return value + " is invalid boolean value";
        }
    };
    BooleanColumn.prototype.getColumnConfig = function () {
        return this.state;
    };
    BooleanColumn.prototype.render = function () {
        var _a;
        return React.createElement(React.Fragment, null, (_a = this.props) === null || _a === void 0 ? void 0 : _a.children);
    };
    return BooleanColumn;
}(Component));
export { BooleanColumn };
export default BooleanColumn;
/**
 *
 */
var BooleanRenderer = /** @class */ (function (_super) {
    __extends(BooleanRenderer, _super);
    function BooleanRenderer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BooleanRenderer.prototype.render = function () {
        var _a = this.props, data = _a.data, style = _a.style;
        if (data === undefined || data === null) {
            data = "";
        }
        return (React.createElement("div", { style: __assign(__assign({}, defaultColumnRendererStyle), style) }, data.toString()));
    };
    return BooleanRenderer;
}(Component));
export { BooleanRenderer };
