var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { Component } from "react";
import { defaultColumnRendererStyle, } from "./Column";
import CheckBoxEditor from "../editors/CheckboxEditor";
/**
 *
 */
var CheckboxColumn = /** @class */ (function (_super) {
    __extends(CheckboxColumn, _super);
    function CheckboxColumn(props) {
        var _this = _super.call(this, props) || this;
        _this.state = __assign(__assign({}, _this.props), { sorter: { sorterFn: _this.sorterFn.bind(_this) }, renderer: React.createElement(CheckboxRenderer, { columnConfig: _this.props }), editor: React.createElement(CheckBoxEditor, null), validator: _this.validateCheckbox });
        return _this;
    }
    CheckboxColumn.prototype.sorterFn = function (a, b) {
        var str_a = a[this.state.field].toString();
        var str_b = b[this.state.field].toString();
        return str_a.localeCompare(str_b, undefined, {
            numeric: true,
            sensitivity: "base",
        });
    };
    CheckboxColumn.prototype.validateCheckbox = function (value) {
        value = String(value);
        if (value !== "true" && value !== "false") {
            return value + " is invalid checkbox value";
        }
    };
    CheckboxColumn.prototype.getColumnConfig = function () {
        return this.state;
    };
    CheckboxColumn.prototype.render = function () {
        var _a;
        return React.createElement(React.Fragment, null, (_a = this.props) === null || _a === void 0 ? void 0 : _a.children);
    };
    return CheckboxColumn;
}(Component));
export { CheckboxColumn };
export default CheckboxColumn;
/**
 *
 */
var CheckboxRenderer = /** @class */ (function (_super) {
    __extends(CheckboxRenderer, _super);
    function CheckboxRenderer(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = _this.handleChange.bind(_this);
        _this.state = {
            value: _this.props.data,
        };
        return _this;
    }
    CheckboxRenderer.prototype.handleChange = function (event) {
        var toggleValue = this.props.toggleValue;
        var value = event.target.checked;
        var _a = this.props.columnConfig.editable, editable = _a === void 0 ? true : _a;
        if (editable) {
            this.setState({ value: value }, function () {
                if (toggleValue) {
                    toggleValue(value);
                }
            });
        }
    };
    CheckboxRenderer.prototype.render = function () {
        var value = this.props.data;
        var style = this.props.style;
        var checkboxComp = (React.createElement("span", { className: "grui-custom-checkbox" },
            React.createElement("input", { type: "checkbox", checked: value, onChange: this.handleChange }),
            React.createElement("label", null)));
        return (React.createElement("div", { style: __assign(__assign({}, defaultColumnRendererStyle), style) }, checkboxComp));
    };
    return CheckboxRenderer;
}(Component));
export { CheckboxRenderer };
