var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { Component } from "react";
import TextField from "../editors/TextEditor";
/**
 *
 */
export var defaultColumnRendererStyle = {
    padding: 12,
};
export var defaultColumnRendererClass = {
    padding: 12,
};
/**
 * The Sencha Grid <Column /> component.
 */
var Column = /** @class */ (function (_super) {
    __extends(Column, _super);
    function Column(props) {
        var _this = _super.call(this, props) || this;
        _this.state = __assign({ sorter: { sorterFn: _this.sorterFn.bind(_this) }, summaries: {
                none: true,
                sum: true,
                min: true,
                max: true,
                average: true,
                variance: true,
                variancep: true,
                stddev: true,
                stddevp: true,
                count: false,
            }, renderer: (React.createElement(ColumnRenderer, { style: props.style, className: props.className })), editor: React.createElement(TextField, null) }, _this.props);
        return _this;
    }
    Column.prototype.sorterFn = function (a, b) {
        return a[this.state.field].localeCompare(b[this.state.field], undefined, {
            numeric: true,
            sensitivity: "base",
        });
    };
    Column.prototype.getColumnConfig = function () {
        return this.state;
    };
    Column.prototype.render = function () {
        var _a;
        return React.createElement(React.Fragment, null, (_a = this.props) === null || _a === void 0 ? void 0 : _a.children);
    };
    return Column;
}(Component));
export { Column };
export default Column;
/**
 * Default column renderer, which renders data as a string.
 */
var ColumnRenderer = /** @class */ (function (_super) {
    __extends(ColumnRenderer, _super);
    function ColumnRenderer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ColumnRenderer.prototype.render = function () {
        var _a = this.props, data = _a.data, style = _a.style, className = _a.className;
        if (data === undefined || data === null) {
            data = "";
        }
        return (React.createElement(React.Fragment, null,
            React.createElement("div", { style: __assign(__assign({}, defaultColumnRendererStyle), style), className: className }, String(data))));
    };
    return ColumnRenderer;
}(Component));
export { ColumnRenderer };
