import { Component } from "react";
import { ColumnConfig, ColumnProps, RendererProps } from "./Column";
import { DateEditorProps } from "../editors/DateEditor";
/**
 *
 */
export interface DateColumnProps extends ColumnProps {
    /**
     * Date renderer properties
     */
    rendererProps?: DateRendererProps;
    /**
     * Date editor properties
     */
    editorProps?: DateEditorProps;
}
/**
 *
 */
export declare class DateColumn extends Component<DateColumnProps, DateColumnProps> implements ColumnConfig<DateColumnProps> {
    constructor(props: DateColumnProps);
    sorterFn(a: any, b: any): any;
    validateDate(value: any): string | true | undefined;
    getColumnConfig(): DateColumnProps;
    render(): JSX.Element;
}
export default DateColumn;
export interface DateRendererProps extends RendererProps {
    /**
     * Intl.DateFormat locales
     */
    dateTimeFormatLocales?: string | string[];
    /**
     * Intl.DateFormatOptions options
     */
    dateTimeFormatOptions?: Intl.DateTimeFormatOptions;
}
/**
 *
 */
export declare class DateRenderer extends Component<DateRendererProps> {
    private formatter;
    constructor(props: DateRendererProps);
    render(): JSX.Element;
}
