var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { Component } from "react";
import { defaultColumnRendererStyle, } from "./Column";
import DateEditor from "../editors/DateEditor";
/**
 *
 */
var DateColumn = /** @class */ (function (_super) {
    __extends(DateColumn, _super);
    function DateColumn(props) {
        var _this = _super.call(this, props) || this;
        var _a = _this.props, renderer = _a.renderer, rendererProps = _a.rendererProps, editor = _a.editor, editorProps = _a.editorProps, validator = _a.validator;
        var dateRenderer = renderer;
        var dateEditor = editor;
        var dateValidator = validator;
        if (!dateRenderer) {
            dateRenderer = React.createElement(DateRenderer, __assign({}, rendererProps));
        }
        if (!dateEditor) {
            editor = React.createElement(DateEditor, __assign({}, editorProps));
        }
        if (!validator) {
            dateValidator = _this.validateDate;
        }
        _this.state = __assign(__assign({}, _this.props), { sorter: { sorterFn: _this.sorterFn.bind(_this) }, renderer: dateRenderer, editor: editor, validator: dateValidator, summaries: {
                none: true,
                min: true,
                max: true,
                count: false
            } });
        return _this;
        // this.state = {
        //   ...this.props,
        //   renderer: <DateRenderer />,
        //   editor: <DateEditor />,
        //   validator: this.validateDate,
        // };
    }
    DateColumn.prototype.sorterFn = function (a, b) {
        return a[this.state.field].localeCompare(b[this.state.field], undefined, {
            numeric: true,
            sensitivity: "base",
        });
    };
    DateColumn.prototype.validateDate = function (value) {
        var date = new Date(value);
        if (value instanceof Date) {
            return true;
        }
        if (date.toString() === "Invalid Date") {
            return value + " is invalid date";
        }
    };
    DateColumn.prototype.getColumnConfig = function () {
        return this.state;
    };
    DateColumn.prototype.render = function () {
        var _a;
        return React.createElement(React.Fragment, null, (_a = this.props) === null || _a === void 0 ? void 0 : _a.children);
    };
    return DateColumn;
}(Component));
export { DateColumn };
export default DateColumn;
/**
 *
 */
var DateRenderer = /** @class */ (function (_super) {
    __extends(DateRenderer, _super);
    function DateRenderer(props) {
        var _this = _super.call(this, props) || this;
        var _a = _this.props, dateTimeFormatOptions = _a.dateTimeFormatOptions, dateTimeFormatLocales = _a.dateTimeFormatLocales;
        var locales = dateTimeFormatLocales;
        if (!locales) {
            locales = "en-US";
        }
        var options = __assign({}, dateTimeFormatOptions);
        _this.formatter = new Intl.DateTimeFormat(locales, options);
        return _this;
    }
    DateRenderer.prototype.render = function () {
        var _a = this.props, data = _a.data, style = _a.style;
        var date = new Date(data);
        var sdate = "";
        try {
            sdate = this.formatter.format(date);
        }
        catch (e) {
            // ignore problems
        }
        return (React.createElement("div", { style: __assign(__assign({}, defaultColumnRendererStyle), style) }, sdate));
    };
    return DateRenderer;
}(Component));
export { DateRenderer };
