import { Component } from "react";
import { NumberEditorProps } from "../editors/NumberEditor";
import { ColumnConfig, ColumnProps, RendererProps } from "./Column";
/**
 *
 */
export interface DecimalColumnProps extends ColumnProps {
    /**
     * Number renderer properties
     */
    rendererProps?: DecimalRendererProps;
    /**
     * Number editor properties
     */
    editorProps?: NumberEditorProps;
}
/**
 *
 */
export declare class DecimalColumn extends Component<DecimalColumnProps, DecimalColumnProps> implements ColumnConfig<DecimalColumnProps> {
    constructor(props: DecimalColumnProps);
    sorterFn(a: any, b: any): any;
    validateDecimal(value: any): boolean;
    getColumnConfig(): DecimalColumnProps;
    render(): JSX.Element;
}
export default DecimalColumn;
/**
 *
 */
export interface DecimalRendererProps extends RendererProps {
    /**
     * Intl.NumberFormat locales
     */
    numberFormatLocales?: string | string[];
    /**
     * Intl.NumberFormatOptions options
     */
    numberFormatOptions?: Intl.NumberFormatOptions;
}
/**
 *
 */
export declare class DecimalRenderer extends Component<DecimalRendererProps> {
    private formatter;
    constructor(props: DecimalRendererProps);
    render(): JSX.Element;
}
