var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { Component } from "react";
import NumberEditor from "../editors/NumberEditor";
import { defaultColumnRendererStyle, } from "./Column";
/**
 *
 */
var DecimalColumn = /** @class */ (function (_super) {
    __extends(DecimalColumn, _super);
    function DecimalColumn(props) {
        var _this = _super.call(this, props) || this;
        var _a = _this.props, renderer = _a.renderer, rendererProps = _a.rendererProps, editor = _a.editor, editorProps = _a.editorProps, validator = _a.validator;
        var decimalRenderer = renderer;
        var decimalEditor = editor;
        var decimalValidator = validator;
        if (!decimalRenderer) {
            decimalRenderer = React.createElement(DecimalRenderer, __assign({}, rendererProps));
        }
        if (!decimalEditor) {
            editor = React.createElement(NumberEditor, __assign({}, editorProps));
        }
        if (!validator) {
            decimalValidator = _this.validateDecimal;
        }
        _this.state = __assign(__assign({}, _this.props), { sorter: { sorterFn: _this.sorterFn.bind(_this) }, renderer: decimalRenderer, editor: editor, validator: decimalValidator });
        return _this;
    }
    DecimalColumn.prototype.sorterFn = function (a, b) {
        var str_a = a[this.state.field].toString();
        var str_b = b[this.state.field].toString();
        return str_a.localeCompare(str_b, undefined, {
            numeric: true,
            sensitivity: "base",
        });
    };
    DecimalColumn.prototype.validateDecimal = function (value) {
        //+ sign will try to convert any value to number
        return !isNaN(+value) && value.toString().split(".").length === 2;
    };
    DecimalColumn.prototype.getColumnConfig = function () {
        return this.state;
    };
    DecimalColumn.prototype.render = function () {
        var _a;
        return React.createElement(React.Fragment, null, (_a = this.props) === null || _a === void 0 ? void 0 : _a.children);
    };
    return DecimalColumn;
}(Component));
export { DecimalColumn };
export default DecimalColumn;
/**
 *
 */
var DecimalRenderer = /** @class */ (function (_super) {
    __extends(DecimalRenderer, _super);
    function DecimalRenderer(props) {
        var _this = _super.call(this, props) || this;
        var _a = _this.props, numberFormatOptions = _a.numberFormatOptions, numberFormatLocales = _a.numberFormatLocales;
        var locales = numberFormatLocales;
        if (!locales) {
            locales = "en-US";
        }
        var options = __assign({}, numberFormatOptions);
        _this.formatter = new Intl.NumberFormat(locales, options);
        return _this;
    }
    DecimalRenderer.prototype.render = function () {
        var _a = this.props, data = _a.data, style = _a.style;
        if (data === undefined || data === null) {
            data = "";
        }
        return (React.createElement("div", { style: __assign(__assign({}, defaultColumnRendererStyle), style) }, this.formatter.format(data)));
    };
    return DecimalRenderer;
}(Component));
export { DecimalRenderer };
