var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { Component } from "react";
import TextEditor from "../editors/TextEditor";
import { defaultColumnRendererStyle, } from "./Column";
/**
 *
 */
var EmailColumn = /** @class */ (function (_super) {
    __extends(EmailColumn, _super);
    function EmailColumn(props) {
        var _this = _super.call(this, props) || this;
        _this.state = __assign(__assign({}, _this.props), { sorter: { sorterFn: _this.sorterFn.bind(_this) }, renderer: React.createElement(EmailRenderer, { style: props.style }), editor: React.createElement(TextEditor, null), validator: _this.validateEmail });
        return _this;
    }
    EmailColumn.prototype.sorterFn = function (a, b) {
        return a[this.state.field].localeCompare(b[this.state.field], undefined, {
            numeric: true,
            sensitivity: "base",
        });
    };
    EmailColumn.prototype.validateEmail = function (value) {
        var re = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        if (!re.test(value)) {
            return value + " is invalid email format.";
        }
    };
    EmailColumn.prototype.getColumnConfig = function () {
        return this.state;
    };
    EmailColumn.prototype.render = function () {
        var _a;
        return React.createElement(React.Fragment, null, (_a = this.props) === null || _a === void 0 ? void 0 : _a.children);
    };
    return EmailColumn;
}(Component));
export { EmailColumn };
export default EmailColumn;
/**
 *
 */
var EmailRenderer = /** @class */ (function (_super) {
    __extends(EmailRenderer, _super);
    function EmailRenderer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EmailRenderer.prototype.render = function () {
        var _a = this.props, data = _a.data, style = _a.style;
        if (data === undefined || data === null) {
            data = "";
        }
        return (React.createElement("div", { style: __assign(__assign({}, defaultColumnRendererStyle), style) }, data));
    };
    return EmailRenderer;
}(Component));
export { EmailRenderer };
