import { Component } from "react";
import { NumberEditorProps } from "../editors/NumberEditor";
import { ColumnConfig, ColumnProps, RendererProps } from "./Column";
/**
 *
 */
export interface FloatColumnProps extends ColumnProps {
    /**
     * Number renderer properties
     */
    rendererProps?: FloatRendererProps;
    /**
     * Number editor properties
     */
    editorProps?: NumberEditorProps;
}
/**
 *
 */
export declare class FloatColumn extends Component<FloatColumnProps, FloatColumnProps> implements ColumnConfig<FloatColumnProps> {
    constructor(props: FloatColumnProps);
    sorterFn(a: any, b: any): any;
    validateFloat(value: any): boolean;
    getColumnConfig(): FloatColumnProps;
    render(): JSX.Element;
}
export default FloatColumn;
/**
 *
 */
export interface FloatRendererProps extends RendererProps {
    /**
     * Intl.NumberFormat locales
     */
    numberFormatLocales?: string | string[];
    /**
     * Intl.NumberFormatOptions options
     */
    numberFormatOptions?: Intl.NumberFormatOptions;
}
/**
 *
 */
export declare class FloatRenderer extends Component<FloatRendererProps> {
    private formatter;
    constructor(props: FloatRendererProps);
    render(): JSX.Element;
}
