import { Component } from "react";
import { NumberEditorProps } from "../editors/NumberEditor";
import { ColumnConfig, ColumnProps, RendererProps } from "./Column";
/**
 *
 */
export interface IntegerColumnProps extends ColumnProps {
    /**
     * Number renderer properties
     */
    rendererProps?: IntegerRendererProps;
    /**
     * Number editor properties
     */
    editorProps?: NumberEditorProps;
}
/**
 *
 */
export declare class IntegerColumn extends Component<IntegerColumnProps, IntegerColumnProps> implements ColumnConfig<IntegerColumnProps> {
    constructor(props: IntegerColumnProps);
    sorterFn(a: any, b: any): any;
    validateInteger(value: any): boolean;
    getColumnConfig(): IntegerColumnProps;
    render(): JSX.Element;
}
export default IntegerColumn;
/**
 *
 */
export interface IntegerRendererProps extends RendererProps {
    /**
     * Intl.NumberFormat locales
     */
    numberFormatLocales?: string | string[];
    /**
     * Intl.NumberFormatOptions options
     */
    numberFormatOptions?: Intl.NumberFormatOptions;
}
/**
 *
 */
export declare class IntegerRenderer extends Component<IntegerRendererProps> {
    private formatter;
    constructor(props: IntegerRendererProps);
    render(): JSX.Element;
}
