import { Component } from "react";
import { NumberEditorProps } from "../editors/NumberEditor";
import { ColumnConfig, ColumnProps, RendererProps } from "./Column";
/**
 *
 */
export interface MoneyColumnProps extends ColumnProps {
    /**
     * Number renderer properties
     */
    rendererProps?: MoneyRendererProps;
    /**
     * Number editor properties
     */
    editorProps?: NumberEditorProps;
}
/**
 *
 */
export declare class MoneyColumn extends Component<MoneyColumnProps, MoneyColumnProps> implements ColumnConfig<MoneyColumnProps> {
    constructor(props: MoneyColumnProps);
    sorterFn(a: any, b: any): any;
    validateMoney(value: any): boolean;
    getColumnConfig(): MoneyColumnProps;
    render(): JSX.Element;
}
export default MoneyColumn;
/**
 *
 */
export interface MoneyRendererProps extends RendererProps {
    /**
     * Intl.NumberFormat locales
     */
    numberFormatLocales?: string | string[];
    /**
     * Intl.NumberFormatOptions options
     */
    numberFormatOptions?: Intl.NumberFormatOptions;
}
/**
 *
 */
export declare class MoneyRenderer extends Component<MoneyRendererProps> {
    private formatter;
    constructor(props: MoneyRendererProps);
    render(): JSX.Element;
}
