import { Component } from "react";
import { ColumnConfig, ColumnProps, RendererProps } from "./Column";
import { NumberEditorProps } from "../editors/NumberEditor";
/**
 * Number column properties
 */
export interface NumberColumnProps extends ColumnProps {
    /**
     * Number renderer properties
     */
    rendererProps?: NumberRendererProps;
    /**
     * Number editor properties
     */
    editorProps?: NumberEditorProps;
}
/**
 * Display, edit and validate a number data type in a column.
 */
export declare class NumberColumn extends Component<NumberColumnProps, NumberColumnProps> implements ColumnConfig<NumberColumnProps> {
    constructor(props: NumberColumnProps);
    sorterFn(a: any, b: any): any;
    validateNumber(value: any): boolean;
    getColumnConfig(): NumberColumnProps;
    render(): JSX.Element;
}
export default NumberColumn;
/**
 *
 */
export interface NumberRendererProps extends RendererProps {
    /**
     * Intl.NumberFormat locales
     */
    numberFormatLocales?: string | string[];
    /**
     * Intl.NumberFormatOptions options
     */
    numberFormatOptions?: Intl.NumberFormatOptions;
}
/**
 *
 */
export declare class NumberRenderer extends Component<NumberRendererProps> {
    private formatter;
    constructor(props: NumberRendererProps);
    render(): JSX.Element;
}
