var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { Component } from "react";
import { defaultColumnRendererStyle, } from "./Column";
import NumberEditor from "../editors/NumberEditor";
/**
 * Display, edit and validate a number data type in a column.
 */
var NumberColumn = /** @class */ (function (_super) {
    __extends(NumberColumn, _super);
    function NumberColumn(props) {
        var _this = _super.call(this, props) || this;
        var _a = _this.props, renderer = _a.renderer, rendererProps = _a.rendererProps, editor = _a.editor, editorProps = _a.editorProps, validator = _a.validator;
        var numberRenderer = renderer;
        var numberEditor = editor;
        var numberValidator = validator;
        if (!numberRenderer) {
            numberRenderer = React.createElement(NumberRenderer, __assign({}, rendererProps));
        }
        if (!numberEditor) {
            editor = React.createElement(NumberEditor, __assign({}, editorProps));
        }
        if (!validator) {
            numberValidator = _this.validateNumber;
        }
        _this.state = __assign(__assign({}, _this.props), { sorter: { sorterFn: _this.sorterFn.bind(_this) }, renderer: numberRenderer, editor: editor, validator: numberValidator });
        return _this;
    }
    NumberColumn.prototype.sorterFn = function (a, b) {
        var str_a = a[this.state.field].toString();
        var str_b = b[this.state.field].toString();
        return str_a.localeCompare(str_b, undefined, {
            numeric: true,
            sensitivity: "base",
        });
    };
    NumberColumn.prototype.validateNumber = function (value) {
        /*+ sign will try to convert any value to number*/
        return !isNaN(+value);
    };
    NumberColumn.prototype.getColumnConfig = function () {
        return this.state;
    };
    NumberColumn.prototype.render = function () {
        var _a;
        return React.createElement(React.Fragment, null, (_a = this.props) === null || _a === void 0 ? void 0 : _a.children);
    };
    return NumberColumn;
}(Component));
export { NumberColumn };
export default NumberColumn;
/**
 *
 */
var NumberRenderer = /** @class */ (function (_super) {
    __extends(NumberRenderer, _super);
    function NumberRenderer(props) {
        var _this = _super.call(this, props) || this;
        var _a = _this.props, numberFormatOptions = _a.numberFormatOptions, numberFormatLocales = _a.numberFormatLocales;
        var locales = numberFormatLocales;
        if (!locales) {
            locales = "en-US";
        }
        var options = __assign({}, numberFormatOptions);
        _this.formatter = new Intl.NumberFormat(locales, options);
        return _this;
    }
    NumberRenderer.prototype.render = function () {
        var _a = this.props, data = _a.data, style = _a.style;
        if (data === undefined || data === null) {
            data = "";
        }
        return (React.createElement("div", { style: __assign(__assign({}, defaultColumnRendererStyle), style) }, this.formatter.format(data)));
    };
    return NumberRenderer;
}(Component));
export { NumberRenderer };
