import { Component } from "react";
import { NumberEditorProps } from "../editors/NumberEditor";
import { ColumnConfig, ColumnProps, RendererProps } from "./Column";
/**
 *
 */
export interface PercentageColumnProps extends ColumnProps {
    /**
     * Number renderer properties
     */
    rendererProps?: PercentageRendererProps;
    /**
     * Number editor properties
     */
    editorProps?: NumberEditorProps;
}
/**
 *
 */
export declare class PercentageColumn extends Component<PercentageColumnProps, PercentageColumnProps> implements ColumnConfig<PercentageColumnProps> {
    constructor(props: PercentageColumnProps);
    sorterFn(a: any, b: any): any;
    validatePercentage(value: any): boolean;
    getColumnConfig(): PercentageColumnProps;
    render(): JSX.Element;
}
export default PercentageColumn;
export interface PercentageRendererProps extends RendererProps {
    /**
     * Intl.NumberFormat locales
     */
    numberFormatLocales?: string | string[];
    /**
     * Intl.NumberFormatOptions options
     */
    numberFormatOptions?: Intl.NumberFormatOptions;
}
/**
 *
 */
export declare class PercentageRenderer extends Component<PercentageRendererProps> {
    private formatter;
    constructor(props: PercentageRendererProps);
    render(): JSX.Element;
}
