var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { Component } from "react";
import PhoneEditor from "../editors/PhoneEditor";
import { defaultColumnRendererStyle, } from "./Column";
/**
 *
 */
var PhoneColumn = /** @class */ (function (_super) {
    __extends(PhoneColumn, _super);
    function PhoneColumn(props) {
        var _this = _super.call(this, props) || this;
        _this.state = __assign(__assign({}, _this.props), { sorter: { sorterFn: _this.sorterFn.bind(_this) }, renderer: React.createElement(PhoneRenderer, { style: props.style }), editor: React.createElement(PhoneEditor, null), validator: _this.validatePhone });
        return _this;
    }
    PhoneColumn.prototype.sorterFn = function (a, b) {
        return a[this.state.field].localeCompare(b[this.state.field], undefined, {
            numeric: true,
            sensitivity: "base",
        });
    };
    PhoneColumn.prototype.validatePhone = function (value) {
        // let regExp =
        //   /^[\+]?(()?\d{1,3}())?((-|\s)?\d{3}())?(-|\s)?\d{3,4}(-|\s)?\d{4}$/;
        var regExp = /^(\+\d{1,2}\s)?\(?\d{3}\)?[\s.-]?\d{3}[\s.-]?\d{4}$/;
        if (!regExp.test(value)) {
            return value + " is invalid phone format";
        }
    };
    PhoneColumn.prototype.getColumnConfig = function () {
        return this.state;
    };
    PhoneColumn.prototype.render = function () {
        var _a;
        return React.createElement(React.Fragment, null, (_a = this.props) === null || _a === void 0 ? void 0 : _a.children);
    };
    return PhoneColumn;
}(Component));
export { PhoneColumn };
export default PhoneColumn;
/**
 *
 */
var PhoneRenderer = /** @class */ (function (_super) {
    __extends(PhoneRenderer, _super);
    function PhoneRenderer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PhoneRenderer.prototype.render = function () {
        var _a = this.props, data = _a.data, style = _a.style;
        if (data === undefined || data === null) {
            data = "";
        }
        return (React.createElement("div", { style: __assign(__assign({}, defaultColumnRendererStyle), style) }, data));
    };
    return PhoneRenderer;
}(Component));
export { PhoneRenderer };
