var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React, { Component } from "react";
/**
 *
 */
var PagingToolbar = /** @class */ (function (_super) {
    __extends(PagingToolbar, _super);
    function PagingToolbar(props) {
        var _this = _super.call(this, props) || this;
        _this.handleClick = function (value) {
            var gotoPage = _this.props.gotoPage;
            _this.setState({ currentPage: value }, function () {
                if (gotoPage) {
                    gotoPage(value);
                }
            });
        };
        _this.handleFirstpage = function () {
            var gotoFirst = _this.props.gotoFirst;
            _this.setState({ currentPage: 1 }, function () {
                if (gotoFirst) {
                    gotoFirst();
                }
            });
            _this.setState({ maxPageNumberLimit: 5 });
            _this.setState({ minPageNumberLimit: 0 });
        };
        _this.handlePrevbtn = function (value) {
            var gotoPrev = _this.props.gotoPrev;
            var _a = _this.state, currentPage = _a.currentPage, pageNumberLimit = _a.pageNumberLimit, maxPageNumberLimit = _a.maxPageNumberLimit, minPageNumberLimit = _a.minPageNumberLimit;
            _this.setState({ currentPage: currentPage - 1 }, function () {
                if (gotoPrev) {
                    gotoPrev();
                }
            });
            if ((currentPage - 1) % pageNumberLimit === 0) {
                _this.setState({
                    maxPageNumberLimit: maxPageNumberLimit - pageNumberLimit,
                });
                _this.setState({
                    minPageNumberLimit: minPageNumberLimit - pageNumberLimit,
                });
            }
        };
        _this.handleNextbtn = function (value) {
            var gotoNext = _this.props.gotoNext;
            var _a = _this.state, currentPage = _a.currentPage, pageNumberLimit = _a.pageNumberLimit, maxPageNumberLimit = _a.maxPageNumberLimit, minPageNumberLimit = _a.minPageNumberLimit;
            _this.setState({ currentPage: currentPage + 1 }, function () {
                if (gotoNext) {
                    gotoNext();
                }
            });
            if (currentPage + 1 > maxPageNumberLimit) {
                _this.setState({
                    maxPageNumberLimit: maxPageNumberLimit + pageNumberLimit,
                });
                _this.setState({
                    minPageNumberLimit: minPageNumberLimit + pageNumberLimit,
                });
            }
        };
        _this.handleLastpage = function () {
            var gotoPage = _this.props.gotoPage;
            _this.setState({ currentPage: 2000 }, function () {
                if (gotoPage) {
                    gotoPage(2000);
                }
            });
            _this.setState({ maxPageNumberLimit: 2000 });
            _this.setState({ minPageNumberLimit: 1995 });
        };
        _this.state = {
            currentPage: 1,
            itemsPerPage: 5,
            pageNumberLimit: 5,
            maxPageNumberLimit: 5,
            minPageNumberLimit: 0,
        };
        return _this;
    }
    PagingToolbar.prototype.render = function () {
        var _this = this;
        var _a = this.state, currentPage = _a.currentPage, maxPageNumberLimit = _a.maxPageNumberLimit, minPageNumberLimit = _a.minPageNumberLimit;
        var pages = [];
        for (var i = 1; i <= 2000; i++) {
            pages.push(i);
        }
        var renderPageNumbers = pages.map(function (number) {
            if (number < maxPageNumberLimit + 1 && number > minPageNumberLimit) {
                return (React.createElement("li", { key: number, id: number.toString(), onClick: function () { return _this.handleClick(number); }, className: currentPage === number ? "active" : undefined }, number));
            }
            else {
                return null;
            }
        });
        var pageIncrementBtn = null;
        if (pages.length > maxPageNumberLimit) {
            pageIncrementBtn = React.createElement("span", { style: { marginTop: "15px" } }, "\u2026");
        }
        var pageDecrementBtn = null;
        if (pages.length > maxPageNumberLimit) {
            pageDecrementBtn = React.createElement("span", { style: { marginTop: "15px" } }, "\u2026");
        }
        return (React.createElement(React.Fragment, null,
            React.createElement("ul", { className: "grui-pageNumbers" },
                React.createElement("li", null,
                    React.createElement("button", { className: "grui-toolbar-first-page", disabled: currentPage === pages[0] ? true : false, onClick: this.handleFirstpage })),
                React.createElement("li", null,
                    React.createElement("button", { className: "grui-toolbar-chevron-left", disabled: currentPage === pages[0] ? true : false, onClick: this.handlePrevbtn })),
                currentPage !== pages[0] ? pageDecrementBtn : null,
                renderPageNumbers,
                currentPage !== pages[pages.length - 1] ? pageIncrementBtn : null,
                React.createElement("li", null,
                    React.createElement("button", { className: "grui-toolbar-chevron-right", disabled: currentPage === pages[pages.length - 1] ? true : false, onClick: this.handleNextbtn })),
                React.createElement("li", null,
                    React.createElement("button", { className: "grui-toolbar-last-page", disabled: currentPage === pages[pages.length - 1] ? true : false, onClick: this.handleLastpage })))));
    };
    return PagingToolbar;
}(Component));
export { PagingToolbar };
export default PagingToolbar;
// export class PagingToolbar extends Component<PagingToolbarProps, PageingState> {
//   constructor(props: PagingToolbarProps) {
//     super(props);
//     this.state = { currentPageNumber: 1 };
//   }
//   render(): ReactElement {
//     const { onFirst, onPrev, onNext, onLast, gotoPage } = this.props;
//     const { currentPageNumber } = this.state;
//     return (
//       <div>
//         <button onClick={onFirst}>First</button>
//         <button onClick={onPrev}>Prev</button>
//         <input
//           value={currentPageNumber}
//           onChange={(e) => {
//             this.pageChange(e, gotoPage);
//           }}
//         />
//         <button onClick={onNext}>Next</button>
//         <button onClick={onLast}>Last</button>
//       </div>
//     );
//   }
//   pageChange(e: any, gotoPage: any) {
//     this.setState({ currentPageNumber: e.target.value });
//     gotoPage(Number(e.target.value));
//   }
// }
// export default PagingToolbar;
