var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { Component } from "react";
/**
 *
 */
var BooleanEditor = /** @class */ (function (_super) {
    __extends(BooleanEditor, _super);
    function BooleanEditor(props) {
        var _this = _super.call(this, props) || this;
        _this.ref = React.createRef();
        _this.getInputEl = _this.getInputEl.bind(_this);
        _this.setValue = _this.setValue.bind(_this);
        _this.getValue = _this.getValue.bind(_this);
        _this.validate = _this.validate.bind(_this);
        _this.getErrors = _this.getErrors.bind(_this);
        _this.handleChange = _this.handleChange.bind(_this);
        _this.handleKeyDown = _this.handleKeyDown.bind(_this);
        _this.state = {
            value: _this.props.defaultValue,
        };
        return _this;
    }
    BooleanEditor.prototype.setValue = function (value) {
        this.setState(__assign(__assign({}, this.state), { value: Boolean(value) }));
    };
    BooleanEditor.prototype.getValue = function () {
        return this.state.value;
    };
    BooleanEditor.prototype.validate = function () {
        var valid = this.state.value !== "";
        return valid;
    };
    BooleanEditor.prototype.getErrors = function () {
        var errors = [];
        if (!this.validate()) {
            errors.push("Please enter a value");
        }
        return errors;
    };
    BooleanEditor.prototype.getInputEl = function () {
        return this.ref.current;
    };
    BooleanEditor.prototype.handleKeyDown = function (event) {
        if (event.key == "Enter") {
            event.currentTarget.blur();
        }
    };
    BooleanEditor.prototype.render = function () {
        var value = this.state.value;
        var onFocusLeave = this.props.onFocusLeave;
        var inputStyle = {
            width: "100%",
            height: "100%",
        };
        return (React.createElement("select", { style: inputStyle, ref: this.ref, value: value, onChange: this.handleChange, onBlur: onFocusLeave },
            React.createElement("option", { value: "false" }, "False"),
            React.createElement("option", { value: "true" }, "True")));
    };
    BooleanEditor.prototype.handleChange = function (event) {
        this.setState(__assign(__assign({}, this.state), { value: event.currentTarget.value }));
    };
    return BooleanEditor;
}(Component));
export { BooleanEditor };
export default BooleanEditor;
