/**
 * These properties make up an Editor component.
 * The data grid will forward the properties to this component when it is intialized and rendered.
 */
export interface IEditor {
    /**
     * Set the data value.
     */
    setValue(value: any): void;
    /**
     * Returns the data value.
     */
    getValue(): any;
    /**
     * Initiate the validation routine in the component.
     * The data grid will call this when it's time to validate.
     * Or call this to activate the validation routine.
     */
    validate(): boolean;
    /**
     * Returns the list of errors resulting from validation.
     */
    getErrors(): string[];
}
export default IEditor;
