var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React, { Component } from "react";
/**
 *
 */
var PhoneEditor = /** @class */ (function (_super) {
    __extends(PhoneEditor, _super);
    function PhoneEditor(props) {
        var _this = _super.call(this, props) || this;
        _this.ref = React.createRef();
        _this.isNumericInput = function (event) {
            var key = event.keyCode;
            return ((key >= 48 && key <= 57) || // Allow number line
                (key >= 96 && key <= 105) // Allow number pad
            );
        };
        _this.formatToPhone = function (event) {
            var target = event.target;
            var input = event.target.value.replace(/\D/g, "").substring(0, 10); // First ten digits of input only
            var zip = input.substring(0, 3);
            var middle = input.substring(3, 6);
            var last = input.substring(6, 10);
            if (input.length > 6) {
                target.value = "(".concat(zip, ") ").concat(middle, "-").concat(last);
            }
            else if (input.length > 3) {
                target.value = "(".concat(zip, ") ").concat(middle);
            }
            else if (input.length > 0) {
                target.value = "(".concat(zip);
            }
        };
        _this.getInputEl = _this.getInputEl.bind(_this);
        _this.setValue = _this.setValue.bind(_this);
        _this.getValue = _this.getValue.bind(_this);
        _this.validate = _this.validate.bind(_this);
        _this.getErrors = _this.getErrors.bind(_this);
        _this.handleChange = _this.handleChange.bind(_this);
        _this.handleKeyDown = _this.handleKeyDown.bind(_this);
        _this.state = {
            value: _this.props.defaultValue,
        };
        return _this;
    }
    PhoneEditor.prototype.setValue = function (value) {
        this.setState({
            value: value,
        });
    };
    PhoneEditor.prototype.getValue = function () {
        return this.state.value;
    };
    PhoneEditor.prototype.validate = function () {
        var valid = this.state.value !== "";
        return valid;
    };
    PhoneEditor.prototype.getErrors = function () {
        var errors = [];
        if (!this.validate()) {
            errors.push("Please enter a value");
        }
        return errors;
    };
    PhoneEditor.prototype.getInputEl = function () {
        return this.ref.current;
    };
    PhoneEditor.prototype.handleKeyDown = function (event) {
        if (!this.isNumericInput(event)) {
            event.preventDefault();
        }
    };
    PhoneEditor.prototype.handleChange = function (event) {
        this.setState({
            value: event.currentTarget.value,
        });
    };
    PhoneEditor.prototype.render = function () {
        var inputStyle = {
            width: "100%",
            height: "100%",
        };
        return (React.createElement("input", { style: inputStyle, ref: this.ref, value: this.state.value, onChange: this.handleChange, onBlur: this.props.onFocusLeave, 
            // onKeyDown={this.handleKeyDown}
            onKeyUp: this.formatToPhone, maxLength: 14 }));
    };
    return PhoneEditor;
}(Component));
export { PhoneEditor };
export default PhoneEditor;
