var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React, { Component } from "react";
/**
 *
 */
var TextEditor = /** @class */ (function (_super) {
    __extends(TextEditor, _super);
    function TextEditor(props) {
        var _this = _super.call(this, props) || this;
        _this.ref = React.createRef();
        _this.getInputEl = _this.getInputEl.bind(_this);
        _this.setValue = _this.setValue.bind(_this);
        _this.getValue = _this.getValue.bind(_this);
        _this.validate = _this.validate.bind(_this);
        _this.getErrors = _this.getErrors.bind(_this);
        _this.handleChange = _this.handleChange.bind(_this);
        _this.handleKeyDown = _this.handleKeyDown.bind(_this);
        _this.isSpaceCharacter = false;
        _this.state = {
            value: _this.props.defaultValue,
        };
        return _this;
    }
    TextEditor.prototype.setValue = function (value) {
        this.setState({
            value: value,
        });
    };
    TextEditor.prototype.getValue = function () {
        return this.state.value;
    };
    TextEditor.prototype.validate = function () {
        var valid = this.state.value !== "";
        return valid;
    };
    TextEditor.prototype.getErrors = function () {
        var errors = [];
        if (!this.validate()) {
            errors.push("Please enter a value");
        }
        return errors;
    };
    TextEditor.prototype.getInputEl = function () {
        return this.ref.current;
    };
    TextEditor.prototype.handleKeyDown = function (event) {
        if (event.code === "Space") {
            this.setState({
                value: this.getValue() + " ",
            });
            this.isSpaceCharacter = true;
        }
        else {
            this.isSpaceCharacter = false;
        }
    };
    TextEditor.prototype.handleChange = function (event) {
        if (this.isSpaceCharacter) {
            return;
        }
        this.setState({
            value: event.currentTarget.value,
        });
    };
    TextEditor.prototype.render = function () {
        var inputStyle = {
            width: "100%",
            height: "100%",
        };
        return (React.createElement("input", { type: "text", style: inputStyle, ref: this.ref, value: this.state.value, onChange: this.handleChange, onBlur: this.props.onFocusLeave, onKeyDown: this.handleKeyDown }));
    };
    return TextEditor;
}(Component));
export { TextEditor };
export default TextEditor;
