/**
 * Fired when a column first creates its column menu. This is to allow plugins to access and manipulate the column menu.
 */
export interface ColumnMenuCreated {
    /**
     * The column's new menu
     */
    menuItems: any;
    /**
     * Column Field Name
     */
    fieldName: string;
    /**
     * Index of the column in the grid
     */
    columnIndex: number;
    /**
     * Menu dom element in the grid
     */
    menuDomElement: HTMLElement;
}
export default ColumnMenuCreated;
