import React, { Component } from "react";
import EditorProps from "../EditorProps";
import IEditor from "./IFilters";
/**
 *
 */
export interface SelectFilterProps extends EditorProps {
    options?: any[];
    onValueChange?(value: string): void;
    operators?: string[];
    onOperatorChangeCallback?(value: string): void;
    operator?: string;
    createOperatoeMenu?(): void;
}
/**
 *
 */
interface SelectFilterState {
    value: any;
}
/**
 *
 */
export declare class SelectFilter extends Component<SelectFilterProps, SelectFilterState> implements IEditor {
    private ref;
    constructor(props: SelectFilterProps);
    setValue(value: string): void;
    getValue(): string;
    validate(): boolean;
    getErrors(): string[];
    getInputEl(): HTMLSelectElement | null;
    handleKeyDown(event: React.KeyboardEvent<HTMLSelectElement>): void;
    handleChange(event: React.ChangeEvent<HTMLSelectElement>): void;
    render(): JSX.Element;
}
export default SelectFilter;
