import React, { Component } from "react";
import EditorProps from "../EditorProps";
import IFilter from "./IFilters";
/**
 *
 */
export interface TextFilterProps extends EditorProps {
    onValueChange?(value: string): void;
    operators?: string[];
    onOperatorChangeCallback?(value: string): void;
    operator?: string;
    createOperatorMenu?(): void;
}
/**
 *
 */
interface TextFilterState {
    value: any;
}
/**
 *
 */
export declare class TextFilter extends Component<TextFilterProps, TextFilterState> implements IFilter {
    private ref;
    constructor(props: TextFilterProps);
    setValue(value: string): void;
    getValue(): string;
    validate(): boolean;
    getErrors(): string[];
    getInputEl(): HTMLInputElement | null;
    handleKeyDown(event: React.KeyboardEvent<HTMLInputElement>): void;
    render(): JSX.Element;
    handleChange(event: React.ChangeEvent<HTMLInputElement>): void;
}
export default TextFilter;
